HDU 1069 Monkey and Banana

题目链接:HDU 1069

Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".

Sample Input

1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output

Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

题意

给定规格的长方体若干,把这些长方体摞起来,每种长方体可以用无数次,但是要求上面的长方体长和宽必须严格小于下面的,等于也不行,所以实际上是每输入一个长方体,就有6种规则可以用。求最高的高度。

题解:

DP经典题目,其实我现在做这道题还是有一点懵的。
在输入的时候每记录一个长方体,就把它的6种变形规格存进去,然后排序,排序时按照长或者宽作为标准,任选其一。在DP的时候DP[i]表示在用到前i个方块的时候最高的高度,状态转移式为DP[i]=max(dp[i],dp[j]+E[i].h),其中j表示比i小的所有方块遍历一遍。

代码

#define _CRT_SECURE_NO_WARNINGS
#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<string>
#include<cstring>
#include<vector>
#include<stack>
#include<bitset>
#include<cstdlib>
#include<cmath>
#include<set>
#include<list>
#include<deque>
#include<map>
#include<queue>
using namespace std;

typedef long long ll;

const double PI = acos(-1.0);
const double eps = 1e-6;
const int INF = 0x3f3f3f3f;
const int N = 2e5 + 5;
struct cube {
	int x, y, h;
	cube(int a, int b, int c) {
		x = a;
		y = b;
		h = c;
	}
	bool operator<(const cube b)const {
		if (y == b.y)return x > b.x;
		return y > b.y;
	}
};
vector<cube>E;
bool judge(cube a, cube b) {
	return a.x > b.x&&a.y > b.y;
}
int main() {
	int n;
	int a, b, c;
	int Case = 1;
	int dp[100];
	while (cin >> n,n) {
		E.clear();
		for (int i(0); i < n; i++)
		{
			cin >> a >> b >> c;
			E.push_back(cube(a, b, c));
			E.push_back(cube(a, c, b));
			E.push_back(cube(b, a, c));
			E.push_back(cube(b, c, a));
			E.push_back(cube(c, a, b));
			E.push_back(cube(c, b, a));
		}
		sort(E.begin(), E.end());
		int lenth = E.size();
		int ans = -INF;
		for (int i(0); i < lenth; i++) {
			dp[i] = E[i].h;
			for (int j(0); j < i; j++) {
				if (judge(E[j], E[i]))
					dp[i] = max(dp[i], dp[j] + E[i].h);
			}
			ans = max(ans, dp[i]);
		}
		ans = max(a, ans);
		cout << "Case " << Case++ << ": maximum height = " << ans << endl;
	}
	return 0;
}
原文地址:https://www.cnblogs.com/Titordong/p/9594473.html